

CREATE TABLE js_params (
	name VARCHAR(64),
	value VARCHAR(255),
	PRIMARY KEY (name)
);

CREATE TABLE js_users (
	fullUserId VARCHAR(97),
	userId VARCHAR(32),
	userServerId VARCHAR(64),
	uName VARCHAR(64),
	keyC1 VARCHAR(1),
	keyC4 VARCHAR(32),
	keyC5 VARCHAR(32),
	keyC6 VARCHAR(255),
	sent TINYINT,
	created DATETIME,
	lastUsed DATETIME,
	PRIMARY KEY (fullUserId),
	CONSTRAINT JS_USERS_IX1 INDEX (userServerId, userId)
);

CREATE TABLE js_user_score (
	roomId VARCHAR(64),
	fullUserId VARCHAR(97),
	score INTEGER,
	PRIMARY KEY (roomId, fullUserId),
	CONSTRAINT JS_USER_SCORE_IX1 INDEX (roomId, score DESC)
);



CREATE TABLE js_options (
	gameType VARCHAR(64),
	optionId VARCHAR(64),
	optionHash INTEGER,
	optionText VARCHAR(50000),
	created DATETIME,
	lastUsed DATETIME,
	useCount INTEGER,
	showFlag CHAR(1),
	gameVersion SMALLINT,
	CONSTRAINT JS_OPTIONS_PK PRIMARY KEY (gameType, optionId),
	CONSTRAINT JS_OPTIONS_IX1 INDEX (gameType, optionHash),
	CONSTRAINT JS_OPTIONS_IX2 INDEX (gameType, showFlag)
);
CREATE TABLE js_option_info (
	gameType VARCHAR(64),
	optionId VARCHAR(64),
	lang CHAR(2),
	info VARCHAR(255),
	CONSTRAINT JS_OPTION_INFO_PK PRIMARY KEY (gameType, optionId, lang)
);



CREATE TABLE js_long_games (
	roomId VARCHAR(64),
	gameId VARCHAR(64),
	ownerFullUserId VARCHAR(97),
	gameKind SMALLINT,
	optionId VARCHAR(64),
	gameOrder INTEGER,
	gameContent VARCHAR(50000),
	created DATETIME,
	lastUsed DATETIME,
	gameVersion SMALLINT,
	CONSTRAINT JS_LONG_GAMES_PK PRIMARY KEY (gameId),
	CONSTRAINT JS_LONG_GAMES_IX1 INDEX (roomId, ownerFullUserId),
	CONSTRAINT JS_LONG_GAMES_IX2 INDEX (roomId, gameOrder, lastUsed DESC),
	CONSTRAINT JS_LONG_GAMES_IX3 INDEX (lastUsed DESC)
);
CREATE TABLE js_long_game_players (
	roomId VARCHAR(64),
	gameId VARCHAR(64),
	fullUserId VARCHAR(97),
	player INTEGER,
	CONSTRAINT JS_LONG_GAME_PLAYERS_PK PRIMARY KEY (gameId, fullUserId),
	CONSTRAINT JS_LONG_GAME_PLAYERS_IX1 INDEX (fullUserId, roomId)
);
