<?php

//
// JavuServer Plugin. Copyright (c) 2007 Krzysztof A. Sadlocha
// This file is licensed under the General Public License (GPL)
//


include_once('jj_funs2.php');

function jj_getConfig()
{
	static $config;

	if($config!=null) return $config;

	function jj_tmpErrorHandler($errno, $errstr, $errfile, $errline) {}

	set_error_handler("jj_tmpErrorHandler");

	include_once('jj_config.php');
	$try2= false;
	if(!function_exists('jj_getConfigImpl')) $try2= true;
	else
	{
		$config= jj_getConfigImpl();
		if($config['conf_begin']!="1" || $config['conf_end']!="1")
		{
			$try2= true;
			$config= null;
		}
	}
	if($try2)
	{
		include_once('jj_config2.php');
	}
	if(function_exists('jj_getConfigImpl'))
	{
		$config= jj_getConfigImpl();
		if($config['conf_begin']!="1" || $config['conf_end']!="1")
		{
			$config= null;
		}
	}
	if($config==null) $config= array();

	restore_error_handler();

	return $config;
}

function jj_applet($config, $userId= null, $password_hash= null)
{
	$mark= $config['PAGE_JWD_MARK'];
	if(empty($mark)) $mark= "<!-- -JAVU-WEB-DIRECTORY-PAGE- -->";
	$out= "\n".$mark."\n";

	$invalid= false;
	$roomId= $_POST['roomId'];
	if(empty($roomId)) $roomId= $_GET['roomId'];
	$jjsid= $_POST['jjsid'];
	if(empty($jjsid)) $jjsid= $_GET['jjsid'];


	$jarpath= $config['jarpath'];
	if(empty($jarpath)) $invalid= true;
	$codeBase= $config['codeBase'];
	if(empty($codeBase)) $invalid= true;
	$javuBase= $config['javuBase'];
	if(empty($javuBase)) $invalid= true;
	$serverId= $config['serverId'];
	if(empty($serverId)) $invalid= true;
	$B92= $config['keyB92'];
	if(empty($B92)) $invalid= true;


	if(empty($config['room_'.$roomId.'_id']))
	{
		$roomId= $config['room_default'];
	}
	if(empty($config['room_'.$roomId.'_id'])) $invalid= true;
	$type= $config['room_'.$roomId.'_type'];
	if(empty($type)) $invalid= true;
	$skin= $config['room_'.$roomId.'_skin'];


	if($invalid)
	{
		$out.= "<b>".htmlspecialchars($config['text_30'], ENT_QUOTES)."</b>";
		return $out;
	}

	if(!empty($userId) && !empty($password_hash))
	{
		$C4= JJFuns2::encC4($password_hash, $serverId);
		$C5= JJFuns2::encC5($C4, $serverId);
		$fullUserId= JJFuns2::encFullUserId($userId, $serverId);
		$jjsid= JJFuns2::encSidN($B92, $C5, $fullUserId);
	}

	$out.= "<APPLET \n";
	$out.= " width='".$config['room_applet_width']."'\n";
	$out.= " height='".$config['room_applet_height']."'\n";
	if($type=="chat")
	{
		$out.= " code='com.javujavu.gamesnchat.chat.ChatApplet'\n";
		$out.= " archive='"
				.$jarpath."javux4chat.jar,"
				.$jarpath."chat.jar'\n";
	}
	else
	{
		$out.= " code='com.javujavu.gamesnchat.game.GameApplet'\n";
		$out.= " archive='"
				.$jarpath."javux4game.jar,"
				.$jarpath."game.jar,"
				.$jarpath.$type.".jar'\n";
	}
	$out.= " codebase='".$codeBase."'\n";
	$out.= " alt='Java Applet'>\n Java Applet\n";
	$out.= " <param name='javuBase' value='".$javuBase."' />\n";
	$out.= " <param name='serverId' value='".$serverId."' />\n";
	$out.= " <param name='roomId' value='".$roomId."' />\n";
	$out.= " <param name='type' value='".$type."' />\n";
	$out.= " <param name='skin' value='".$skin."' />\n";
	$out.= " <param name='tabs' value='".$config['room_applet_tabs']."' />\n";
	$out.= " <param name='emots' value='".$config['room_applet_emots']."' />\n";
	$out.= " <param name='authGuests' value='".$config['jwd_auth_guests']."' />\n";
	$out.= " <param name='authShare' value='".$config['jwd_auth_share']."' />\n";
	$out.= " <param name='authLocal' value='".$config['jwd_auth_local']."' />\n";
	$out.= " <param name='lang' value='".$config['server_language']."' />\n";
	if($jjsid!=null)
	{
		$out.= " <param name='jjsid' value='".$jjsid."' />\n";
	}
	$out.= "<param name='jjtpPort' value='".$config['jjtp_port']."' />\n";
	$out.= "</APPLET>\n";
	$out.= "<APPLET width='1' height='3'"
		." code='com.javujavu.gamesnchat.store.StaticApplet'\n"
		." archive='".$jarpath."store.jar'\n"
		." codebase='".$codeBase."'\n"
		." name='jjStaticSession'\n"
		.">\n</APPLET>\n";

	return $out;
}
function jj_list($config)
{
	$out= "";
	$roomId= $_POST['roomId'];
	if(empty($roomId)) $roomId= $_GET['roomId'];
	if(empty($config['room_'.$roomId.'_id']))
	{
		$roomId= $config['room_default'];
	}

	$doc= $config['docBase'];
	if(empty($doc)) return $out;
	if(empty($config['keyB92'])) return $out;


	$out.= "<table align='center' border='0' cellspacing='4'>\n";


	$doc.= (strpos($doc, '?')===false) ? '?roomId=' : '&roomId=';
	for($i= 1; $i<10; $i++)
	{
		$id= "room".$i;
		$type= $config['room_'.$id.'_type'];
		if(empty($config['room_'.$id.'_id'])
			|| empty($type)) continue;
		$desc= htmlspecialchars($config['room_'.$id.'_desc'], ENT_QUOTES);
		$img= "<IMG border='0' align='absmiddle' src='".$config['javuBase']."jj_images/$type.icon16.gif'/>";
		$out.= "<tr><td align='left'>\n";
		if($id==$roomId)
		{
			$out.= "$img&nbsp;&nbsp;<B>$desc</B>\n";
		}
		else
		{
			$out.= "<A href='".$doc.$id."'>$img</A>&nbsp;&nbsp;<A href='".$doc.$id."'>$desc</A>\n";
		}
		$out.= "</td></tr>\n";
	}
	$out.= "</table>\n";
	return $out;
}

?>